DROP DATABASE bank;
CREATE DATABASE bank;
use bank;

CREATE TABLE `USER` (
  `ID` int(11) NOT NULL AUTO_INCREMENT,
  `NAME` varchar(30) NOT NULL,
  `LAST_NAME1` varchar(30) NOT NULL,
  `LAST_NAME2` varchar(30),
  `EMAIL` varchar(50) NOT NULL UNIQUE,
  `PHONE` varchar(20),
  `ACTIVE` Boolean NOT NULL DEFAULT 1,
  PRIMARY KEY (`ID`)
);

CREATE TABLE `CLIENT` (
  `ID` int(11) NOT NULL AUTO_INCREMENT,
  `NAME` varchar(30) NOT NULL,
  `LAST_NAME1` varchar(30) NOT NULL,
  `LAST_NAME2` varchar(30),
  `EMAIL` varchar(50)  NOT NULL UNIQUE,
  `PHONE` varchar(20),
  `ACTIVE` Boolean NOT NULL DEFAULT 1,
  `IDENTIFIER` varchar(20) NOT NULL UNIQUE,
  `USER_ID` int(11),
  PRIMARY KEY (`ID`),
  FOREIGN KEY (`USER_ID`) REFERENCES `USER`(`ID`)
);

CREATE TABLE `CURRENCY` (
  `ID` int(11) NOT NULL AUTO_INCREMENT,
  `NAME` varchar(30) NOT NULL UNIQUE,
  `SYMBOL` varchar(10) NOT NULL,
  `CODE` varchar(15) NOT NULL UNIQUE,
  PRIMARY KEY (`ID`)
);

CREATE TABLE `ACCOUNT` (
  `ID` int(11) NOT NULL AUTO_INCREMENT,
  `IBAN` varchar(50) NOT NULL UNIQUE,
  `BALANCE` decimal(12,2) NOT NULL DEFAULT 0,
  `CLIENT_ID` int(11),
  `CURRENCY_ID` int(11),
  `ACTIVE` Boolean NOT NULL DEFAULT 1,
  PRIMARY KEY (`ID`),
  FOREIGN KEY (`CLIENT_ID`) REFERENCES `CLIENT`(`ID`),
  FOREIGN KEY (`CURRENCY_ID`) REFERENCES `CURRENCY`(`ID`),
);

CREATE TABLE `FUND` (
  `ID` int(11) NOT NULL AUTO_INCREMENT,
  `NAME` varchar(30) NOT NULL UNIQUE,
  `REF_NUMBER` varchar(30) NOT NULL UNIQUE,
  `CURRENCY_ID` int(11),
  `ACTIVE` Boolean NOT NULL DEFAULT 1,
  `ACTIVE_DATE` DATE NOT NULL,
  `INACTIVE_DATE` DATE,
  PRIMARY KEY (`ID`),
  FOREIGN KEY (`CURRENCY_ID`) REFERENCES `CURRENCY`(`ID`)
);

CREATE TABLE `PRODUCT` (
    `ID` int(11) NOT NULL AUTO_INCREMENT,
    `NAME` varchar(30) NOT NULL,
    `ACTIVE` Boolean NOT NULL DEFAULT 1,
    `ACTIVE_DATE` DATE NOT NULL,
    `INACTIVE_DATE` DATE,
    PRIMARY KEY (`ID`)
);


CREATE TABLE `FUNDS_PRODUCTS` (
    `FUND_ID` int(11),
    `PRODUCT_ID` int(11),
    PRIMARY KEY (`FUND_ID`, `PRODUCT_ID`),
    FOREIGN KEY (`FUND_ID`) REFERENCES `FUND`(`ID`),
    FOREIGN KEY (`PRODUCT_ID`) REFERENCES `PRODUCT`(`ID`)
);

CREATE TABLE `TRANSACTION` (
    `ID` int(11) NOT NULL AUTO_INCREMENT,
    `DATE` datetime NOT NULL,
    `TRANSACTION_NUMBER` varchar(40) NOT NULL UNIQUE,
    `AMOUNT` decimal(12,2) NOT NULL,
    `ACCOUNT_ID` int(11),
    `FUND_ID` int(11),
    PRIMARY KEY (`ID`),
    FOREIGN KEY (`ACCOUNT_ID`) REFERENCES `ACCOUNT`(`ID`),
    FOREIGN KEY (`FUND_ID`) REFERENCES `FUND`(`ID`)
);

